//IE系列禁止反选
//document.onselectstart=function(){
	//var type = event.srcElement.type;
	//if(type === "text" || type === "password") {
	//	return true;
	//}
	//return false;
//}

if(typeof sohuHD === 'undefined') sohuHD = {};

// Simple JavaScript Templating
// John Resig - http://ejohn.org/ - MIT Licensed
(function (sohuHD) {
    var cache = {};
    sohuHD.tmpl = function tmpl(str, data) {
        // Figure out if we're getting a template, or if we need to
        // load the template - and be sure to cache the result.
        var fn = !/\W/.test(str) ? (cache[str] = cache[str] || tmpl(document.getElementById(str).innerHTML))
        // Generate a reusable function that will serve as a template
        // generator (and which will be cached).
        :
        new Function("obj", "var p=[],print=function(){p.push.apply(p,arguments);};" +

        // Introduce the data as local variables using with(){}
        "with(obj){p.push('" +

        // Convert the template into pure JavaScript
        str.replace(/[\r\t\n]/g, " ").split("<%").join("\t").replace(/((^|%>)[^\t]*)'/g, "$1\r").replace(/\t=(.*?)%>/g, "',$1,'").split("\t").join("');").split("%>").join("p.push('").split("\r").join("\\'") + "');}return p.join('');");

        // Provide some basic currying to the user
        return data ? fn(data) : fn;
    };
})(sohuHD);

/**
 * 模板引擎
 * https://github.com/xwcoder/template
 */
( function ( global ) {
    global = global || this;

    var apply = function ( t, s, defaults ) {
        if ( defaults ) {
            extend( t, defaults );
        }
        if ( s && typeof s == 'object' ) {
            for ( var p in s ) {
                t[ p ] = s[ p ];
            }
        }
        return t;
    };

    /**
     * @notice 内建指令，提醒自己千万不要过度设计。用不到include等等。
     */
    var globalDirs = {
        h : { name : 'helper', dir : 'helper' }
    };

    var trimReg = /(^\s*)|(\s*$)/g;
    var trim = ''.trim ? function ( s ) {
            return s.trim(); 
        } : function ( s ) {
        return ( s || '' ).replace( trimReg, '' ); 
    };

    function Helper () {}

    apply( Helper.prototype, {
        trim : trim,
        /**
         *  @param date Date类型或毫秒数时间戳
         *  @param f 格式化字符串 如'yyyy-MM-dd', 'yyyy年MM月dd日'
         *  @return s 格式化后的字符串
         */
        dateFormat : function ( date, f ) {
            if ( {}.toString.call( date ) != '[object Date]' ) {
                date = new Date( parseInt( date ) );
            }
            var map = {
                'y+' : date.getFullYear(),
                'M+' : date.getMonth() + 1,
                'd+' : date.getDate(),
                'h+' : date.getHours(),
                'm+' : date.getMinutes(),
                's+' : date.getSeconds()
            };
            for ( var p in map ) {
                if ( new RegExp ( '(' + p + ')' ).test( f ) ) {
                    f = f.replace( RegExp.$1, ( '00' + map[ p ] ).substr( ~RegExp.$1.length + 1 ) );
                }
            }
            return f;
        },

        /**
         * @description 将秒数格式化为指定格式，如'40:23'
         * @param t 秒数
         * @param f 格式化字符串 如'mm:ss', 'mm分ss秒'
         * @return s 格式化后的字符串
         */
        timeFormat : function ( t, f ) {
            t = t / 1;
            var map = {
                'm+' : Math.floor(t / 60),
                's+' : t % 60
            };
            
            f = f.replace( /(m+)/, function ( item, $1 ) {
                var r = $1;
                var l = ( '' + map[ 'm+' ] ).length;
                if ( $1 ) {
                    if ( l > $1.length ) {
                        r = new Array( l + 1 ).join( 'm' );
                    }
                }
                return r;
            } );

            for ( var p in map ) {
                if ( new RegExp ( '(' + p + ')' ).test( f ) ) {
                    f = f.replace( RegExp.$1, ( '00' + map[ p ] ).slice( ~RegExp.$1.length + 1 ) );
                }
            }
            return f;
        },
        
        /**
         * @description 字符串截取
         * @param s {String} 要截取的字符串
         * @param limit {Number} 截取长度
         * @param isSuffix {boolean} 是否添加后缀，默认false
         * @param suffix {String} 后缀，默认'...'
         */
        truncate : function ( s, limit, isSuffix, suffix ) {
            s = s || '';
            if ( s.length <= limit ) {
                return s;
            } 

            s = s.substr( 0, limit );
            if ( isSuffix ) {
                s = s + ( suffix || '...' );
            }
            return s;
        },

        /**
         * @description 字符串截取, 中文按两个字符
         * @param s {String} 要截取的字符串
         * @param limit {Number} 截取长度
         * @param isSuffix {boolean} 是否添加后缀，默认false
         * @param suffix {String} 后缀，默认'...'
         */
        truncateCN : function ( s, limit, isSuffix, suffix ) {
            s = s || '';
            var r =/[^\x00-\xff]/g;
            isSuffix = isSuffix || false;
            suffix = suffix || '...';

            if ( limit > 0 && s.replace( r, 'mm' ).length > limit ) {
                var m = Math.floor( limit / 2 );
                for ( var i = m; i < s.length; i++ ) {
                    if ( s.substr( 0, i ).replace( r, 'mm' ).length >= limit ) {
                        return s.substr( 0, i ) + ( isSuffix ? suffix : '' );
                    }
                }
            }
            return s;
        },
        
        /**
         * @description 将数字分组表示 如 '1234567.00' -> '1,234,567.00'
         * @param s 将分组的字符串
         * @param n n个字符分为一组, 默认是3个
         * @param splitChar 分隔字符，默认是','
         */
        numberGroup : function ( s, n, splitChar ) {
            s = s || '1234567345345.000';
            n = n || 3;
            splitChar = splitChar || ',';

            s = '' + s;

            if ( !/^(\+|-)?(\d+)(\.\d+)?$/.test( s ) ) {
                return s;
            }
            var a = RegExp.$1;
            var b = RegExp.$2;
            var c = RegExp.$3;
            var reg = new RegExp().compile( '(\\d+)(\\d{' + n + '})(' + splitChar + '|$)' );

            while ( reg.test(b) ) {
                b = b.replace(reg, '$1' + splitChar + '$2$3');
            }
            return a + b + c;
        },

        escapeXSS : function ( s ) {
            return ( s || '' ).replace( /</g, '&lt;' ).replace( />/g, '&gt;' );
        }
    } );

    function Template ( content ) {
        this.content = content || ''; 
        this.helper = new Helper();
    }

    apply( Template, {
        render : function ( tmpl, data ) {
            return ( new Template( tmpl ) ).render( data );
        },
        registHelper : function () {
            var helper = {};
            var args = [].slice.call( arguments );
            if ( args.length == 2 && typeof args[ 0 ] == 'string' ) {
                helper[ args[ 0 ] ] = args[ 1 ];
            } else if ( args.length == '1' && typeof args[ 0 ] == 'object' ) {
                helper = args[ 0 ];
            }
            helper && apply( Helper.prototype, helper );
        }
    } );

    apply( Template.prototype, {

        version : '1.0',

        setContent : function ( content ) {
            this.fn = null;
            this.directive = null;
            this.content = content;
        },

        render : function ( data ) {
            this.compile();

            var dirs = this.directive || {}; 
            var name, dirObj;
            for ( var p in globalDirs ) {
                dirObj = globalDirs[ p ];
                name = typeof dirs[ p ] == 'undefined' ? dirObj.name
                                                : dirs[ p ];
                if ( data[ name ] ) {
                    throw new Error( '指令{ ' + name + ' }冲突...' );
                }
                data[ name ] = this[ dirObj.dir ];
            }

            var str = this.fn( data );

            for ( var p in globalDirs ) {
                dirObj = globalDirs[ p ];
                name = typeof dirs[ p ] == 'undefined' ? dirObj.name
                                                : dirs[ p ];
                delete data[ name ];
            }

            return str;
        },

        compile : function () {
            if ( !this.fn ) {
                this.directive = {};
                var tp = this;
                var content = this.content.replace(/[\r\t\n]/g, " ")
                    .replace( /<%@(.*?)%>/g, function ( match, $1 ) {
                        if ( $1 ) {
                            var match = $1.split( ':' );
                            if ( match && match.length ) {
                                tp.directive[ trim( match[ 0 ] ) ] = trim( match[ 1 ] );
                            }
                        }
                        return '';
                    }).replace(/<%!--(.*?)--%>/g, '' ).split("<%").join("\t")
                   .replace(/((^|%>)[^\t]*)'/g, "$1\r")
                   .replace(/\t=(.*?)%>/g, "',$1,'")
                   .split("\t").join("');")
                   .split("%>").join("p.push('")
                   .split("\r").join("\\'");
                   var body = "var p = [];with(obj){p.push('" + content + "');}"
                    + "return p.join('');";
                this.fn = new Function ( 'obj', body );
            }
        },
        registHelper : function () {
            var helper = this[ globalDirs.h.dir ];
            var args = [].slice.call( arguments );
            if ( args.length == 2 && typeof args[ 0 ] == 'string' ) {
                helper[ args[ 0 ] ] = args[ 1 ];
            } else if ( args.length == '1' && typeof args[ 0 ] == 'object' ) {
                apply( helper, args[ 0 ] );
            }
        }
    } );
    
    global.Template = Template;
} )( sohuHD );

/*
 * 一个简单的并行、串行Helper函数，用于实于多个异步请求的串行、并行方式加载。
 * API:
 * sohuHD.tasks({
 * 	task1: 'task1value',
 * 	task2: function(next, result) {
 * 		setTimeout(function() {
 * 			next(null, 'task2value');
 * 		}, 1000);
 * 	}
 * }, function(err, result) {
 * 	//assert(result, {task1:'task1value', task2:'task2value'});
 * });
 * 
 * */
(function (sohuHD) {
	function _tasks(tasks, callback, mode) {
		callback = callback || function () {};
		mode = mode || "series";					//默认使用并行方式
		var i, j, length, result;
		var keys, getkey;
		var iscomplete = false;

		if (tasks.constructor === Array) {
			getkey = function (id) { return id; }
			i = 0;
			j = 0;
			length = tasks.length;
			result = [];
		} else {
			keys = [];
			getkey = function (id) { return keys[id]; }
			for (var key in tasks) { keys.push(key); }
			i = 0;
			j = 0;
			length = keys.length;
			result = {};
		}

		var complete = function(err) {
			j++;
			if (err != null || j >= length) {
				callback(err, result);
				complete = function() {} ;		//noop
				return true;
			}
			return false;
		}

		var next = function (key) {
			var task = tasks[key];
			var type = typeof task;
			if (type === 'function') {
				task(function (err, value) {
					result[key] = value;
					complete(err);
				}, result);						//执行当前任务时把本任务之前结果(不可预知)也传递过去
			} else {
				result[key] = task;
				complete(null);
			}
		}

		if(length > 0) {
			if(mode === 'series') {					//串行模式
				var oldcomplete = complete;
				complete = function(err) {
					if(!oldcomplete(err)){
						i++;
						next(getkey(i));
					}
				}
				next(getkey(i));
			} else if(mode === 'parallel') {		//并行模式
				while(i < length) { 
					next(getkey(i)); 
					i++;
				}
			}
		} else {
			complete(null);	
		}
	}

	sohuHD.tasks = _tasks;

	sohuHD.series = function(tasks, callback) {
		_tasks(tasks, callback, 'series');
	}

	sohuHD.parallel= function(tasks, callback) {
		_tasks(tasks, callback, 'parallel');
	}
})(sohuHD);


sohuHD.json=function(value){
	if(typeof value==="string"){
		return this.json.toObject(value);
	}else{
		return this.json.toJSON(value);
	}
}
sohuHD.json.toJSON=function(object){
	var type = typeof object;
	if ('object' == type) {
		if (Array == object.constructor) type = 'array';
		else if (RegExp == object.constructor) type = 'regexp';
		else type = 'object';
	}
	switch (type) {
		case 'undefined':
		case 'unknown':
			return;
		break;
		case 'function':
		case 'boolean':
		case 'regexp':
			return object.toString();
		break;
		case 'number':
			return isFinite(object) ? object.toString() : 'null';
		break;
		case 'string':
			return '"' + object.replace(/(\\|\")/g, "\\$1").replace(/\n|\r|\t/g, function() {
				var a = arguments[0];
				return (a == '\n') ? '\\n': (a == '\r') ? '\\r': (a == '\t') ? '\\t': ""
			}) + '"';
		break;
		case 'object':
			if (object === null) 
				return 'null';
			var results = [];
			for (var property in object) {
				var value = this.toJSON(object[property]);
				if (value !== undefined) 
					results.push(this.toJSON(property) + ':' + value);
			}
			return '{' + results.join(',') + '}';
		break;
		case 'array':
			var results = [];
			for (var i = 0; i < object.length; i++) {
				var value = this.toJSON(object[i]);
				if (value !== undefined) 
					results.push(value);
			}
			return '[' + results.join(',') + ']';
		break;
	}
}
sohuHD.json.toObject=function(strjson){
	return eval("(" + strjson + ")");
}



sohuHD.cookie = function(name, value, options) {
	if (typeof value != 'undefined') {
		options = options || {};
		if (value === null) {
			value = '';
			options.expires = -1;
		}
		var expires = '';
		if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
			var date;
			if (typeof options.expires == 'number') {
				date = new Date();
				date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
			} else {
				date = options.expires;
			}
			expires = '; expires=' + date.toUTCString();
		}
		var path = options.path ? '; path=' + options.path : '';
		var domain = options.domain ? '; domain=' + options.domain : '';
		var secure = options.secure ? '; secure' : '';
		document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
	} else {
		var cookieValue = null;
		if (document.cookie && document.cookie != '') {
			var cookies = document.cookie.split(';');
			for (var i = 0; i < cookies.length; i++) {
				var cookie = jQuery.trim(cookies[i]);
				if (cookie.substring(0, name.length + 1) == (name + '=')) {
					cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
					break;
				}
			}
		}
		return cookieValue;
	}
}
		
sohuHD.strSub = function (str,n,d,dd){
    var r =/[^\x00-\xff]/g;
    d = d || false;
    dd = dd || '...';
    if(n > 0 && str.replace(r, "mm").length > n){
        var m = Math.floor(n/2);
        for(var i=m; i<str.length; i++){
            if(str.substr(0, i).replace(r, "mm").length>=n){
                return str.substr(0, i) + (d ? dd : "");
            }
        }
    }
    return str;
}

sohuHD.strTransform = function(o) {
	var arr = o.arr;
	var res = [];
	var blank = o.b ? " target='_blank'" : "";
	if(o.n && o.n > 0) {
		arr = arr.slice(0, o.n);
	}
	var sub = o.sub || 0;
	for(var i = 0; i < arr.length; i++) {
		if(arr[i] == "") break;
		res.push([sohuHD.strSub(arr[i], sub)].join(''));
	}
	return res.join('/');
}

sohuHD.getDate = function(t) {
	var d = new Date();
	d.setTime(t);
	return d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate();
};

sohuHD.formatCount = function(mc){
	var reg=/(\d{1,3})(?=(\d{3})+(?:$|\.))/g;
	if(mc>=100000){
		mc=parseInt(mc/10000).toString().replace(reg,"$1,")+"万";
	}else{
		mc=mc.toString().replace(reg,"$1,");
	}
	return mc;
}

sohuHD.redirect = function(url){
    try{
        window.external.OpenWithIE(url);
    }catch(e){ }
};

sohuHD.clearTimer = function(o){
    if(o._timer){
        clearTimeout(o._timer);
        o._timer = null;
        o.fliping = false;
    }
};

sohuHD.flipIn = function(o){
    if(!o.fliping && $(o).parents('li').find(".bico").length === 0){
        o.fliping = true;
        var me = $(o);
        var _html=[];
        o._timer = setTimeout(function(){
            if(me.attr("rel")){
                var rels=me.attr("rel").split("-");
                var vid=rels[0];
                var plid=rels[1];
                var type=rels[2];
                var pid=rels[3];
                me.parents('li').find('span.label').hide();
                $(".bico").mouseout();
                _html.push('<em class="bico">');
                if(!me.parents("a.pic").hasClass("pnews")){
                    _html.push('<a href="javascript:sohuHD.ShowDetail(\'http://tv.sohu.com/feihudetail/#'+vid+'_'+plid+'_'+type+'_'+pid+'\')"><span class="s1" onmouseover="this.className=\'s1 s1over\'" onmousedown="this.className=\'s1 s1down\'"  onmouseout="this.className=\'s1\'"></span></a>');
                }
                _html.push('<a href="javascript:sohuHD.Play('+pid+','+vid+',-1);"><span class="s2" onmouseover="this.className=\'s2 s2over\'" onmousedown="this.className=\'s2 s2down\'"  onmouseout="this.className=\'s2\'"></span></a>');
                if(me.parents("a.pic").attr("down")&&me.parents("a.pic").attr("down")=="1"){
					if(!me.parents("a.pic").hasClass("pnews")){
						_html.push('<a href="javascript:sohuHD.ShowDownload(\'http://tv.sohu.com/feihudetail/#'+vid+'_'+plid+'_'+type+'_'+pid+'_1\')"><span class="s3" onmouseover="this.className=\'s3 s3over\'" onmousedown="this.className=\'s3 s3down\'" onmouseout="this.className=\'s3\'"></span></a>'); 
					}
					else{
						_html.push('<a href="javascript:sohuHD.Download('+pid+','+vid+')"><span class="s3" onmouseover="this.className=\'s3 s3over\'" onmousedown="this.className=\'s3 s3down\'" onmouseout="this.className=\'s3\'"></span></a>');
					 }
				}
                _html.push('</em>');
                me.parents('li').append(_html.join(''));
               
                me[0].fliping = false;

            }
        },200);
    }
};
sohuHD.flipOut = function(o){
    var me = $(o);
    o._timer = setTimeout(function(){
        var pic = me.parents('li').find('a.pic>img');
        var lab=me.parents('li').find('span.label');
        me.remove();
        lab.show();
        if(pic[0])
            pic[0].fliping = false;

    },200);
};


//获取当前url中，扩展的统计参数。
sohuHD.getExtStat = function() {
	var match = /(?:\?|\&)stat=([^\&\#]*)/.exec(window.location.href);
	if(match) {
		return match[1];
	} 
	return "";
}


//播放全网视频 20121009
sohuHD.OPlay = function(jsonStr) {
	var cmd = '\\WholeNetPlay='+jsonStr;
	try {
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		sohuVA.RunSohuPlayer(cmd);
	} catch(e) { 
		try { window.external.RunSohuPlayer(cmd); } catch(e) {;}
	}
}

var STAT_SUPPORTED_VERSION =  67239941;


sohuHD.Play=function(vid,time,isbk,defid,src){
    //try{
	//	var version= this.GetVersion(); 
    //    if(src && version > STAT_SUPPORTED_VERSION) {
	//		window.external.Play(pid,vid,time,isbk,defid, src);
    //    } else if(defid && version > -1){			//兼容没有原画功能的客户端，如果客户端不支持原话，传5参会导致不能播放。
	//		window.external.Play(pid,vid,time,isbk,defid);
	//	}else if(isbk){
	//		window.external.Play(pid,vid,time,isbk);
	//	}else{
	//		window.external.Play(pid,vid,time);
	//	}
	//}catch(e){}
    var params = {
        'vid' : vid,
        'time' : time,
        'isbk' : isbk,
        'defid' : defid,
        'src' : src
    };
    try {
        window.external.Play(sohuHD.json.toJSON(params));
    } catch(e){
        sohuHD.IfoxLog(e);
    }
};
sohuHD.IfoxLog = function(error) {
    try {
        window.external.WriteWebLog(error.message);
    } catch(err) {
        if (window.console != undefined && window.console.log) {
            window.console.log(error.message);
        }
    }
};
sohuHD.Search=function(key){
    try{
        window.external.Search(key);
    }catch(e){}
};
sohuHD.Store=function(pid,vid){
    try{
        window.external.Store(pid,vid);
    }catch(e){}
};

sohuHD.Preload=function(pid,vid,defi,isbk){
    try{
        if(isbk) {
			window.external.Preload(pid,vid,defi,isbk);
		} else {
			window.external.Preload(pid,vid,defi);
        }
    }catch(e){}
};

sohuHD.Preloads=function(pid,vids,defi,isbk){
    try{
        if(isbk) {
			window.external.Preloads(pid,vids,defi,isbk);
        } else {
			window.external.Preloads(pid,vids,defi);
        }
    }catch(e){}
};

sohuHD.Download=function(pid,vid,defi,isbk,src){
    try{
        var version = this.GetVersion();
        if(src && version > STAT_SUPPORTED_VERSION) {
			window.external.Download(pid,vid,defi,isbk,src);
        } else if(isbk) {
			window.external.Download(pid,vid,defi,isbk);
        } else {
			window.external.Download(pid,vid,defi);
        }
    }catch(e){}
};

sohuHD.Downloads=function(pid,vids,defi,isbk,src){
    try{
        var version = this.GetVersion();
        if(src && version > STAT_SUPPORTED_VERSION) {
			window.external.Downloads(pid,vids,defi,isbk,src);
        } else if(isbk) {
			window.external.Downloads(pid,vids,defi,isbk);
        } else {
			window.external.Downloads(pid,vids,defi);
        }
    }catch(e){}
};

sohuHD.ShowDetail=function(url){
    try{
        window.external.ShowDetail(url);
    }catch(e){}
};

sohuHD.ShowDetailWrapper = function (vid, playlistid, pid, cid, idown) {
    idown = idown ? '_' + idown : '';
    var url = 'http://tv.sohu.com/upload/ifox/v4/newdetail.html#'+vid + '_' + playlistid + '_' + cid
                + '_' + pid + idown;
    sohuHD.ShowDetail(url);
};

sohuHD.ShowDownload=function(url){
    try{
        window.external.ShowDownload(url);
    }catch(e){}
};

//详情页登录后刷新中控区
sohuHD.ClientLogin=function(username){
	try{
		if(username)
			window.external.ClientLogin(username);
		else
			window.external.ClientLogin();
	}catch(e){}
}
/*控制客户端中控区面板
 * CancelLogin
 * StartLogin
 * LoginSucceed
 * */
sohuHD.ClientFunction=function(type){
    try{
        window.external.ClientFunction(type);
    }catch(e){ }
}
//获取Ifox，16进制表示的版本号
sohuHD.GetClientVersion=function(){
	try{
		var numOri=window.external.GetClientVersion();
			numOri=parseInt(numOri,10);
		return numOri.toString(16);
	}catch(e){
		return "none";
	}
}
//拉起客户端上传面板。arg1:用户名
sohuHD.UploadVideo=function(username){
	try{
		window.external.UploadVideo(username);
	}catch(e){;}
}


//是否已经创建站内视频快捷桌面
sohuHD.IsShortcutCreated = function(plid){
	/*
	alert(window.external.IsShortcutCreatedEx(plid, 0));
	var test = "\\CreateShortcut=827799,827799,2,5081732,屌丝男士";
	window.external.RunSohuPlayer(test);
	*/
	var res = 'Nonsupport';
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		try {
			res = sohuVA.IsShortcutCreatedEx(plid, 0)? 'Exist': 'NotExist';
		} catch(e) {
			res = sohuVA.IsShortcutCreated(plid)? 'Exist': 'NotExist';
		}
	} catch(e) {
		try {
			res = window.external.IsShortcutCreatedEx(plid, 0)? 'Exist': 'NotExist';
		} catch(e) {
			res = 'Nonsupport';
		}
	}
	return res;
}
//创建站内快捷桌面
sohuHD.CreateUrlShortcut = function(vid,pid,cid,plid,name){
	var res = true;
	var cmd = '\\CreateShortcut='+[vid,pid,cid,plid,name].join(',');
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
			sohuVA.RunSohuPlayer(cmd);
	} catch(e) {
		try {
			window.external.RunSohuPlayer(cmd);
		} catch(e) { 
			res = false;	
		}
	}
	return res;
};

//是否已经创建站外视频快捷桌面
sohuHD.IsShortcutCreated2 = function(plid){
	var res = 'Nonsupport';
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		res = sohuVA.IsShortcutCreatedEx(plid, 2)? 'Exist': 'NotExist';
	} catch(e) {
		try {
			res = window.external.IsShortcutCreatedEx(plid, 2)? 'Exist': 'NotExist';
		} catch(e) {
			res = 'Nonsupport';
		}
	}
	return res;
};

//创建站内外捷桌面
sohuHD.CreateUrlShortcut2 = function(plid,name,jsoninfo){
	var res = true;
	var cmd = '\\CreateWholeNetworkQuickLunch='+jsoninfo+'#;#'+plid+'#;#'+name;
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		sohuVA.RunSohuPlayer(cmd);
	} catch(e) {
		try {
			window.external.RunSohuPlayer(cmd);
		} catch(e) {
			res = false;
		}
	}
	return res;
};

sohuHD.OpenIfoxBroswer = function(url) {
    try { 
        window.external.OpenIfoxBrowser(sohuHD.json.toJSON({'url':url})); 
    } catch(e) {}
};

//获取安装时间
sohuHD.GetInstallTime = function() {
	var date = null;
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		date = sohuVA.GetInstallTime();
	}catch(e){ 
	}
	var c = /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})$/.exec(date);
	if(c) {
		date = 	new Date(parseInt(c[1],10),parseInt(c[2],10)-1,parseInt(c[3],10),parseInt(c[4],10),parseInt(c[5],10),parseInt(c[6],10));
	} else {
		date = null;
	}
	return date;
};

//获取首次安装时间
sohuHD.GetFirstInstallTime = function() {
	var date = null;
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		date = sohuVA.GetFirstInstallTime();
	}catch(e){ }
	var c = /^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})$/.exec(date);
	if(c) {
		date = 	new Date(parseInt(c[1],10),parseInt(c[2],10)-1,parseInt(c[3],10),parseInt(c[4],10),parseInt(c[5],10),parseInt(c[6],10));
	} else {
		date = null;
	}
	return date;
}

//获取10进制表示的版本号
sohuHD.GetVersion = function(){
	var num = -1;
	try{		
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		num = sohuVA.GetSohuVAVersion();
	}catch(e){
		try{
			num = window.external.GetSohuVAVersion();
		}catch(ee){ }
	}
	return parseInt(num ,10);		
}

sohuHD.GetVersionString = function() {
	var v1 = sohuHD.GetVersion();
	if(v1 < 0) return "-1" ;
	var v2 = parseInt(v1/256, 10);
	var v3 = parseInt(v2/256, 10);
	var v4 = parseInt(v3/256, 10);
	return [v4%256,v3%256,v2%256,v1%256].join(".");
}

//获取客户端UID
sohuHD.GetUserId = function() {
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		return sohuVA.GetUserId();
	}catch(e){
		try {
			return window.external.GetUserId();	
		} catch(e) {
			return -1;
		}
	}
	return -1;
}

//
sohuHD.GetChannelNum = function() {
	try{
		var sohuVA = new ActiveXObject('SoHuVA.SoHuDector.1');
		return sohuVA.GetChannelNum();
	}catch(e){
		try {
			return window.external.GetChannelNum();	
		} catch(e) {
			return -1;
		}
	}
	return -1;
}

//V4.0新加接口

//调用客户端刷新
sohuHD.TryAgain = function() {
	try {
		window.external.TryAgain();
	} catch(e) {}
}

sohuHD.LoginSucceed = function(uid, passport, nickname){
	try{
		window.external.LoginSucceed(sohuHD.json.toJSON({'userId':uid, 'passport':passport, 'userName':nickname}));
	}catch(e){
        window.external.WriteWebLog('LoginSucceed invoke Error' + e.message);
    }
}

sohuHD.LogOut = function(){
	try{
		window.external.LogOut();
	}catch(e){;}
}

sohuHD.CloseWnd = function(){
	try{
		window.external.CloseWnd();
	}catch(e){;}
}

sohuHD.LoginThird = function(url, w, h){
	try{
		window.external.LoginThird(sohuHD.json.toJSON({'url':url, 'width':w, 'height':h}));
	}catch(e){;}
}


sohuHD.CloseWebbrowserWnd = function() {
	try{
		window.external.CloseWebbrowserWnd();
	} catch(e) {}
}

sohuHD.ShowFloatDetail = function(x, y, args, isall, stat, src){
	var url1 = 'http://tv.sohu.com/upload/ifox/v4/small-detail.html';
	var url2 = 'http://tv.sohu.com/upload/ifox/v4/small-alldetail.html';
	var url = isall? url2: url1;

    if(stat) {
        url += ('?stat=' + stat);
    }

    if(src) {
        url += (stat?'&':'?');
        url += ('downloadsrc=' + src);
    }
	url = [url, '#', args].join('');
	try{
		window.external.ShowFloatDetail(x, y, url);
	}catch(e){;}
}

sohuHD.HideFloatDetail = function () {
	try{
		window.external.HideFloatDetail();
	}catch(e){;}
};

//中控搜索结果，返回视频列表
sohuHD.ReturnVideoList = function() {
	try{
		window.external.ReturnVideoList();
	}catch(e){;}
}

//浮层详情页，专辑下载弹层
sohuHD.ShowDownloadWeb = function(args, src) {
	var url = "http://tv.sohu.com/upload/ifox/v4/download.html";
    if(src) {
        url += ('?downloadsrc=' + src);
    }
    url += ('#' + args);
	try{
		window.external.ShowDownloadWeb(url);
	}catch(e){;}
}

//通知客户端改变窗口大小
sohuHD.AdjsutWindow = function(title) {
	try{
		window.external.AdjsutWindow(title);
	}catch(e){;}
}

/*
 * 通知客户端发ping
 * arg1 {Number} 0代表ifox专辑页,1代表ifox搜索结果页
 * arg2 {Number} 0代表图标，1代表立即播放/续播，2代表第N集，3代表观看该节目的用户还看了的点击
 */
sohuHD.Playclick = function(arg1, arg2) {
	try{
        //alert([arg1, arg2]);
        window.external.playclick(arg1, arg2);
	}catch(e){;}
}

/*
 * 提供给影音客户端传入一个关键词返回搜索结果页URL
 * */
sohuHD.GetSearchUrl = function(keyword) {
    var path = 'http://so.tv.sohu.com/app3';
    var url = 'http://tv.sohu.com/upload/ifox/v4/so-index.html';
    if (keyword) {
        url = path + '?wd=' + escape(keyword);
    }
    return url;
};


/**
 * 获得某元素的坐标信息, only IE
 * @author xwcoder xwcoder@outlook.com
 * @param {HTML DOM} el
 * @return {object} {
     *  screenX : (左上角)相对于屏幕的横坐标
     *  screenY : (左上角)相对于屏幕的纵坐标
     *  clientX : (左上角)相对于浏览器窗口的横坐标
     *  clientY : (左上角)相对于浏览器窗口的纵坐标
     *  clientBottom : (右下角)相对于浏览器窗口的纵坐标
     *  clientRight : (右下角)相对于浏览器窗口的横坐标
     *  winscreenX : 窗口相对于屏幕的横坐标
     *  winscreenY : 窗口相对于屏幕的纵坐标
     *  winHeight : 窗口高度
     *  winWidth : 窗口宽度
     * }
 */
sohuHD.getPosition = function (el) {
    var client = el.getBoundingClientRect();
    var win = {top : window.screenTop || window.screenY, left : window.screenLeft || window.screenX};
    return {
        screenX : win.left + client.left,
        screenY : win.top + client.top,
        clientX : client.left,
        clientY : client.top,
        clientBottom : client.bottom,
        clientRight : client.right, 
        winscreenX : win.left,
        winscreenY : win.top,
        winHeight : document.documentElement ? document.documentElement.clientHeight : document.body.clientHeight,
        winWidth : document.documentElement ? document.documentElement.clientWidth : document.body.clientWidth
    };
};


sohuHD.pingback = function(url){

    var img = new Image();
    img.onload = img.onerror = img.onabort = function(){
        img = null;
    };
    img.src = url;

};


//对源url添加一组KV Param
sohuHD.addUrlParam = function(oriUrl, strParamName, strParamValue) {
    var addParam = [strParamName, strParamValue].join('=');
    var reg = /(\?|\#)/;
    var rule = {
        '?':        ('?' + addParam + '&'),
        '#':        ('?' + addParam + '#'),
        'default':  ('?' + addParam)
    }

    if(reg.test(oriUrl)) {
        return oriUrl.replace(reg, function(m, n) { return rule[n]; });
    }
    return oriUrl + rule['default'];
};

sohuHD.getUrlParam = function (obj, strParamName) {
    //@obj : 获取参数的对象(a , img , document时获取location.href)
    //@strParamName : 参数名
    var getQueryStrByName = function (val, name) {
        var result = val.match(new RegExp("[?&]" + name + "=([^&]+)", "i"));
        if (result == null || result.length < 1) {
            return "";
        }
        return result[1];
    };

    strParamName = escape(unescape(strParamName));
    if (Object.prototype.toString.call(obj) == '[object String]') {
        return getQueryStrByName(obj, strParamName);
    } else if (obj.nodeName == '#document') {
        return getQueryStrByName(location.search || '', strParamName);
    } else if (typeof obj.src != 'undefined') {
        return getQueryStrByName(obj.src, strParamName);
    } else if (typeof obj.href != 'undefined') {
        return getQueryStrByName(obj.href, strParamName);
    } else {
        return null;
    }
};


if(window.jQuery) {
    function goBack() {
        try{
            window.external.GoBack();
        }catch(e){;}
    }

    function Refresh() {
        try{
            window.external.Refresh();
        }catch(e){;}
    }

    jQuery(function(){
        $('#topBar .ico-pre').click(goBack);
        $('#topBar .ico-fresh').click(Refresh);
    });
};

//导航pingback
;( function ( $ ) {
    var navMap = {
        a1 : '00',  //首页 
        a4 : '01', //电视剧
        a11 : '02', //美剧
        a3 : '03', //电影
        a5 : '04', //动漫
        a8 : '05', //综艺
        a6 : '06', //纪录片
        a7 : '07', //新闻
        a9 : '08', //游戏
        a10 : '09' //会员
    }; 
    $( function () {
        $( '#topBar .nav' ).on( 'click', 'a', function () {
            var className = $.trim( this.className );
            var stype = navMap[ className ];
            if ( typeof stype != 'undefined' ) {
                //var v = sohuHD.GetVersion(); 
                var v = sohuHD.GetVersionString(); 
                var uid = sohuHD.GetUserId();
                var channelID = sohuHD.GetChannelNum();
                var url = 'http://click.hd.sohu.com.cn/ifox.gif?type=home&stype=' + stype + '&v=' + v
                        + '&uid=' + uid + '&ChannelID=' + channelID + '&timestamp=' + new Date().getTime(); 
                //console.log( url );
                //return false;
                sohuHD.pingback( url );

                var href = this.href;
                setTimeout( function () {
                    window.location.href = href;
                }, 60 );
                return false;
            }
        } );
    } );

} )( jQuery );

//页面初始加载一次云迹，取50条数据(接口最多支持30条)
( function ( $ ) {

    var getPassport = function () {
        return typeof window.PassportSC != 'undefined' ? PassportSC.cookieHandle() : '';
    };

    /**
     * @description 获得本站的本地历史记录
     */
    var getLocalHistory = function () {
        var his = $.cookie( 'savehistory' );

        if ( !his ) {
            return [];
        }

        his = his.split( '%2C' );

        var array = [];
        
        $.each( his, function ( index, h ) {
            h = h.split( '^' ); 
            if ( h.length > 1) {
                array.push( { pid : h[0], vid : h[1], order : h[2], newTime : h[3], mix : h[4],/**不知道h[4]是啥**/
                        url : h[5], title : unescape( h[6] ), playTime : parseInt( h[7] ), nurl : h[8] } );
            }
        } );
        return array.reverse();
    };

    var passport = getPassport();

    if ( passport ) {
        $.getJSON( 'http://his.tv.sohu.com/his/get.do?callback=?&pagesize=30&c=6&passport=' + passport, function ( data ) {
            data = data || {};
            data = data.videos || [];
            window._history_data_remote = data;
        } );
    }

    //plid,vid,time,isbk,defid,src    
    sohuHD.playByHistory = function ( plid, vid, time, isbk, defid ) {
        var historyData = window._history_data_remote || [];
        var playData = [vid, time || 0, isbk, defid ];
        
        if ( getPassport() ) { //如果登录匹配云迹
            if ( plid ) {
                $.each( historyData, function ( index, item ) {
                    if ( plid == item.sid ) {
                        playData = [ item.vid, item.t, isbk, defid ];
                        return false;
                    }   
                } );
            }
        } else { //未登录匹配本地记录
            $.each( getLocalHistory(), function ( index, item ) {
                if ( plid == item.plid ) {
                    playData = [ item.vid, item.newTime, isbk, defid ];
                    return false;
                }
            } );
        }
        sohuHD.Play.apply( sohuHD, playData );
    };

} )( jQuery );

(function(){
    //Array.prototype.indexOf
    Array.prototype.indexOf||(Array.prototype.indexOf=function(a){"use strict";if(this===void 0||this===null)throw new TypeError;var b=Object(this),c=b.length>>>0;if(c===0)return-1;var d=0;arguments.length>0&&(d=Number(arguments[1]),d!==d?d=0:d!==0&&(d=(d>0||-1)*Math.floor(Math.abs(d))));if(d>=c)return-1;var e=d>=0?d:Math.max(c-Math.abs(d),0);for(;e<c;e++)if(e in b&&b[e]===a)return e;return-1});
})();
